/*
 * Copyright (c) 2015, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.wso2.developerstudio.msf4j.artifact.util;

public class MSF4JArtifactConstants {

    public static final String MAVEN2_PROJECT_NATURE = "org.eclipse.m2e.core.maven2Nature";
    public static final String MSF4J_PROJECT_NATURE = "org.wso2.developerstudio.eclipse.msf4j.project.nature";
    public static final String IMAGE_FILE = "msf4j-wizard.png";
    public static final Object NEW_MSF4J_PROJECT_CREATION_OPTION = "new.MSF4J";
    public static final String POM_FILE = "pom.xml";

    public static final String MSF4J_SERVICE_PARENT_GROUP_ID = "org.wso2.msf4j";
    public static final String MSF4J_SERVICE_PARENT_ARTIFACT_ID = "msf4j-service";
    public static String MSF4JServiceParentVersion = "2.0.0";
   
	public static final String SWAGGER_ANNOTATIONS_DEPENDENCY_GROUP_ID = "io.swagger";
    public static final String SWAGGER_ANNOTATIONS_DEPENDENCY_ARTIFACT_ID = "swagger-annotations";
    public static final String SWAGGER_ANNOTATIONS_DEPENDENCY_VERSION = "1.5.0";

    public static final String OK_BUTTON = "OK";
    public static final String ERROR_TAG = "ERROR";
    public static final String DEPENDENCY_RESOLVING_TASK = "Resloving Dependencies of generated project...";
    public static final String READING_POM_TASK = "Reading pom.xml file";
    public static final String POM_FILE_PREFIX = "pom";
    public static final String XML_EXTENTION = ".xml";
    public static final Object MAVEN_ECLIPSE_ECLIPSE_GOAL = "eclipse:eclipse";
    public static final String SETTING_MAVEN_INVOKER_TASK = "Setting Maven invoker";
    public static final String EXECUTING_MAVEN_REQUEST_TASK = "Executing Maven Request";
    public static final String PROJECT_REFRESH_TASK = "Refreshing project";
    public static final String MAVEN_DEPENDENCY_RESOLVER_TAG = "Maven Dependency Resolver";
    public static final String MSF4J_MAIN_CLASS_PROPERTY = "msf4j.mainClass";
    public static final String DEFAULT_MAIN_CLASS_PROPERTY_VALUE = "TODO : Update this place with fully qualified service class name";
    public static final String PROJECT_WIZARD_WINDOW_TITLE = "New MSF4J Project";

    public static final String GEN_DIRECTORY = "gen";
    public static final String RESOURCES_DIRECTORY = "resources";
    public static final String JAVA_DIRECTORY = "java";
    public static final String MAIN_DIRECTORY = "main";
    public static final String SRC_DIRECTORY = "src";
    public static final String TRGET_DIRECTORY = "target";
    public static final String WEBAPP_DIRECTORY = "webapp";
    public static final String MSF4J_PROJECT_CREATION_TASK = "Creating MSF4J Project...";
    public static final String PROCESSING_CONFIGURATION_TASK = "Processing configuration...";
    public static final String CODE_GENERATION_TASK = "Generating code...";
    
    public static final String API_EXCEPTION_JAVA = "ApiException.java";
    public static final String API_RESPONSE_MESSAGE_JAVA = "ApiResponseMessage.java";
    public static final String API_ORIGIN_FILTER_JAVA = "ApiOriginFilter.java";
    public static final String NOT_FOUND_EXCEPTION_JAVA = "NotFoundException.java";
    public static final String API = "api";

    
    public static String getMSF4JServiceParentVersion() {
		return MSF4JServiceParentVersion;
	}
	public static void setMSF4JServiceParentVersion(String mSF4J_SERVICE_PARENT_VERSION) {
		MSF4JServiceParentVersion = mSF4J_SERVICE_PARENT_VERSION;
	}
}
